# Filters added to this controller will be run for all controllers in the application.
# Likewise, all the methods added will be available for all controllers.
class ApplicationController < ActionController::Base

  after_filter :set_charset

  def set_charset
    content_type = @headers["Content-Type"] || 'text/html'
    if /^text\//.match(content_type)
      @headers["Content-Type"] = "#{content_type}; charset=ISO-8859-1"
    end
  end

  def authenticate
    unless session[:user_emp_num]
      flash[:notice] = "Please log in"
      redirect_to :controller => "user", :action => "login"
      return false
    end
  end
end