#class Item < ActiveRecord::Base
require_gem "sap4rails"
class Catalogue < SAP4Rails::Base
  # Define function Modules
  function_module :BAPI_ADV_MED_GET_LAYOUT,
    :BAPI_ADV_MED_GET_ITEMS,
    :BAPI_ADV_MED_GET_LAYOBJ_DESCR

  # Get Products of Catalogue
  def self.products
    return @products
  end
  # Get Catalogue Structue
  def self.structure
    @catalog = 'MASTERCAT'
    @variant = '1'
    Catalogue.BAPI_ADV_MED_GET_LAYOUT.reset
    Catalogue.BAPI_ADV_MED_GET_LAYOUT.CATALOG.value = @catalog
    Catalogue.BAPI_ADV_MED_GET_LAYOUT.VARIANT.value =  @variant
    # Catalogue.BAPI_ADV_MED_GET_LAYOUT.WITH_ITEMS.value = 'X'
    # Catalogue.BAPI_ADV_MED_GET_LAYOUT.WITH_PRICES.value = 'X'
    Catalogue.BAPI_ADV_MED_GET_LAYOUT.call
    # Add Items to Productlist
   if Catalogue.BAPI_ADV_MED_GET_LAYOUT.ITEMS != nil
     @products = []
     Catalogue.BAPI_ADV_MED_GET_LAYOUT.ITEMS.hashRows do |r|
       product = {}
       product["product_id"] = r["MATERIAL"]
       @products << product
     end
   end
    # Read Text for Areas
    if Catalogue.BAPI_ADV_MED_GET_LAYOUT.TEXTS != nil
      texts = {}
      Catalogue.BAPI_ADV_MED_GET_LAYOUT.TEXTS.hashRows do |r|
        if r["ITEM"] == "0000000000"
          texts[r["AREA"]] = r["NAME"]
        end
      end
    end
    # Build Structure Array with Texts
    if Catalogue.BAPI_ADV_MED_GET_LAYOUT.AREAS != nil
      structure = []
      Catalogue.BAPI_ADV_MED_GET_LAYOUT.AREAS.hashRows do |r|
        r["NAME"] = texts[r["AREA"]]
        structure << r
      end
    end
    layout = Catalogue.BAPI_ADV_MED_GET_LAYOUT.LAYOUT.value
    return layout, structure
  end
  # Get Items of a specified area
  def self.items(area)
    Catalogue.BAPI_ADV_MED_GET_ITEMS.reset
    Catalogue.BAPI_ADV_MED_GET_ITEMS.CATALOG.value = @catalog
    Catalogue.BAPI_ADV_MED_GET_ITEMS.VARIANT.value = @variant
    Catalogue.BAPI_ADV_MED_GET_ITEMS.AREA.value = area
    Catalogue.BAPI_ADV_MED_GET_ITEMS.WITH_PRICES = 'X'
    Catalogue.BAPI_ADV_MED_GET_ITEMS.call
    # Get Prices
    if Catalogue.BAPI_ADV_MED_GET_ITEMS.PRICES != nil
      prices = {}
      Catalogue.BAPI_ADV_MED_GET_LAYOUT.PRICES.hashRows do |r|
        price = r["CONDVAL"]
        prices[r["ITEM"]] = price.to_s + " " + r["CURRNCY"]
      end
    end
    # Get Texts
    if Catalogue.BAPI_ADV_MED_GET_ITEMS.TEXTS != nil
      texts = {}
      Catalogue.BAPI_ADV_MED_GET_LAYOUT.TEXTS.hashRows do |r|
        texts[r["ITEM"]] = r["NAME"]
      end
    end
    # Build Array of items
    if Catalogue.BAPI_ADV_MED_GET_ITEMS.ITEMS != nil
      items = []
      Catalogue.BAPI_ADV_MED_GET_ITEMS.ITEMS.hashRows do |r|
        r["NAME"] = texts[r["ITEM"]]
        r["PRICE"] = prices[r["ITEM"]]
        # Get desription for Item
        result, lines = areadescription(area, r["ITEM"])
        if lines != nil
          description = ""
          lines.each do |line|
            description += line["LINE"] + "<br />"
          end
          r["DESCRIPTION"] = description
        end
		items << r
      end
    end
    result = Catalogue.BAPI_ADV_MED_GET_ITEMS.RETURN.value
    return result, items
  end

  def self.areadescription(area, item)
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.reset
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.CATALOG.value = @catalog
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.VARIANT.value = @variant
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.AREA.value = area
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.ITEM.value = item
    Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.call
    if Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.LINES != nil
      description = []
      Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.LINES.hashRows do |r|
		description << r
      end
    end
    result = Catalogue.BAPI_ADV_MED_GET_LAYOBJ_DESCR.RETURN.value
    return result, description
  end
end
