require_gem "sap4rails"

class Material < SAP4Rails::Base

  function_module :BAPI_MATERIAL_GET_DETAIL
  parameter :MATERIAL, :MATERIAL_GENERAL_DATA, :RETURN

  function_module :BAPI_MATERIAL_AVAILABILITY
  parameter :MATERIAL, :UNIT, :PLANT, :AV_QTY_PLT

  function_module :MATERIAL_READ_PLANTS
  parameter :MATNR, :PLANTS

  function_module :BAPI_SALESORDER_SIMULATE
  parameter :ORDER_HEADER_IN, :ORDER_ITEMS_IN, :ORDER_PARTNERS, :ORDER_ITEMS_OUT, :RETURN

  def number
    return @number
  end

  def self.detail(material_num)
    @number = material_num
    Material.BAPI_MATERIAL_GET_DETAIL.reset
    Material.BAPI_MATERIAL_GET_DETAIL.MATERIAL.value = material_num
    Material.BAPI_MATERIAL_GET_DETAIL.call
    puts Material.BAPI_MATERIAL_GET_DETAIL.MATERIAL_GENERAL_DATA
    return Material.BAPI_MATERIAL_GET_DETAIL.MATERIAL_GENERAL_DATA.value
  end

  def self.availability(material_num, unit)
    Material.BAPI_MATERIAL_AVAILABILITY.reset
    Material.BAPI_MATERIAL_AVAILABILITY.MATERIAL.value = material_num
    Material.BAPI_MATERIAL_AVAILABILITY.UNIT.value = unit

    Material.MATERIAL_READ_PLANTS.reset
    Material.MATERIAL_READ_PLANTS.MATNR.value = material_num
    Material.MATERIAL_READ_PLANTS.call
    total = 0
    Material.MATERIAL_READ_PLANTS.PLANTS.hashRows do |r|
      plant = r["WERKS"]
      Material.BAPI_MATERIAL_AVAILABILITY.PLANT.value = plant
      Material.BAPI_MATERIAL_AVAILABILITY.call
      total += Material.BAPI_MATERIAL_AVAILABILITY.AV_QTY_PLT.value.to_f
    end
    return total
  end

  def self.price(material_num, quantity)
    Material.BAPI_SALESORDER_SIMULATE.reset
    orderheader = Material.BAPI_SALESORDER_SIMULATE.ORDER_HEADER_IN.structure
    orderheader.DOC_TYPE.value = "AG"
    # TODO save this from login
    orderheader.SALES_ORG.value = "1000"
    # This is needed because of an error in saprf-0.18
    orderheader.REQ_DATE_H.value = '00000000'
    orderheader.PURCH_DATE.value = '00000000'
    orderheader.PRICE_DATE.value = '00000000'
    orderheader.QT_VALID_F.value = '00000000'
    orderheader.QT_VALID_T.value = '00000000'
    orderheader.CT_VALID_F.value = '00000000'
    orderheader.CT_VALID_T.value = '00000000'
    Material.BAPI_SALESORDER_SIMULATE.ORDER_HEADER_IN.value = orderheader.value
    # Order Items
    orderitems = Material.BAPI_SALESORDER_SIMULATE.ORDER_ITEMS_IN.structure
    orderitems.MATERIAL.value = material_num
    orderitems.REQ_QTY.value = quantity.to_s
    Material.BAPI_SALESORDER_SIMULATE.ORDER_ITEMS_IN.value = [ orderitems.value ]
    # Order Partners
    orderpartners = Material.BAPI_SALESORDER_SIMULATE.ORDER_PARTNERS.structure
    orderpartners.PARTN_ROLE.value = "AG"
    # TODO save this from login
    orderpartners.PARTN_NUMB.value = "0001003258"
    Material.BAPI_SALESORDER_SIMULATE.ORDER_PARTNERS.value = [ orderpartners.value ]
    # Call Function
    Material.BAPI_SALESORDER_SIMULATE.call
    ret = Material.BAPI_SALESORDER_SIMULATE.RETURN.value
    subtotal1 = nil
    subtotal2 = nil
    Material.BAPI_SALESORDER_SIMULATE.ORDER_ITEMS_OUT.hashRows do |r|
      subtotal1 = r["SUBTOTAL1"].to_f
      subtotal2 = r["SUBTOTAL2"].to_f
    end
    return {:list => subtotal1, :net => subtotal2}
  end
end
