require_gem "sap4rails"

class SalesOrder < SAP4Rails::Base
  
  function_module :BAPI_SALESORDER_GETLIST  
  parameter :CUSTOMER_NUMBER, :SALES_ORGANIZATION, :TRANSACTION_GROUP, :SALES_ORDERS, :RETURN,
    :MATERIAL, :DOCUMENT_DATE, :DOCUMENT_DATE_TO, :EAN, :ORDER_INDICATOR
  
  function_module :BAPISDORDER_GETDETAILEDLIST
  parameter :I_BAPI_VIEW, :SALES_DOCUMENTS, :ORDER_ITEMS_OUT
    
  def self.list(params)
    SalesOrder.BAPI_SALESORDER_GETLIST.reset
    SalesOrder.BAPI_SALESORDER_GETLIST.CUSTOMER_NUMBER.value = params[:customer_num] unless params[:customer_num].blank?
    SalesOrder.BAPI_SALESORDER_GETLIST.SALES_ORGANIZATION.value = "1000"
    SalesOrder.BAPI_SALESORDER_GETLIST.TRANSACTION_GROUP.value = 0
    SalesOrder.BAPI_SALESORDER_GETLIST.MATERIAL.value = params[:material_num] unless params[:material_num].blank?
    SalesOrder.BAPI_SALESORDER_GETLIST.DOCUMENT_DATE.value = params[:from] unless params[:from].blank?
    SalesOrder.BAPI_SALESORDER_GETLIST.DOCUMENT_DATE_TO.value = params[:to] unless params[:to].blank?
    SalesOrder.BAPI_SALESORDER_GETLIST.call
		result = SalesOrder.BAPI_SALESORDER_GETLIST.RETURN.value
		if result != nil
			RAILS_DEFAULT_LOGGER.warn("---->[list] " + result['MESSAGE'])
		end
    return SalesOrder.BAPI_SALESORDER_GETLIST.SALES_ORDERS, SalesOrder.BAPI_SALESORDER_GETLIST.RETURN.value
  end
  
  def self.details(doc_num)
    SalesOrder.BAPISDORDER_GETDETAILEDLIST.reset
    view = SalesOrder.BAPISDORDER_GETDETAILEDLIST.I_BAPI_VIEW.structure
    view.HEADER.value = "X"
    view.ITEM.value = "X"
    SalesOrder.BAPISDORDER_GETDETAILEDLIST.I_BAPI_VIEW.value = view.value
    salesdocs = SalesOrder.BAPISDORDER_GETDETAILEDLIST.SALES_DOCUMENTS.structure
    salesdocs.VBELN.value = doc_num
    SalesOrder.BAPISDORDER_GETDETAILEDLIST.SALES_DOCUMENTS.value = [ salesdocs.value ]
    SalesOrder.BAPISDORDER_GETDETAILEDLIST.call
    return SalesOrder.BAPISDORDER_GETDETAILEDLIST
  end
end
