require 'digest/sha1'
require_gem 'sap4rails'

class User < SAP4Rails::Base

  function_module :BAPI_PAR_EMPLOYEE_CHECKPASSWOR,
		:BAPI_PAR_EMPLOYEE_CHANGEPASSWO,
		:BAPI_PAR_EMPLOYEE_CHECKEXISTEN,
		:BAPI_CUSTOMER_GETSALESAREAS,
		:BAPI_CUSTOMER_GETDETAIL2,
		:BAPI_BUSPARTNEREMPLOYE_GETLIST

  def self.authenticate(login, pass)
    ret = {}
    User.BAPI_PAR_EMPLOYEE_CHECKPASSWOR.reset
    User.BAPI_PAR_EMPLOYEE_CHECKPASSWOR.PARTNEREMPLOYEEID.value = login
    User.BAPI_PAR_EMPLOYEE_CHECKPASSWOR.PASSWORD.value = pass
    User.BAPI_PAR_EMPLOYEE_CHECKPASSWOR.call
    result = User.BAPI_PAR_EMPLOYEE_CHECKPASSWOR.RETURN.value

    User.BAPI_PAR_EMPLOYEE_CHECKEXISTEN.reset
    User.BAPI_PAR_EMPLOYEE_CHECKEXISTEN.PARTNEREMPLOYEEID.value = login
    User.BAPI_PAR_EMPLOYEE_CHECKEXISTEN.call
    ret[:customer_num] = User.BAPI_PAR_EMPLOYEE_CHECKEXISTEN.CUSTOMER.value

    User.BAPI_CUSTOMER_GETSALESAREAS.reset
    User.BAPI_CUSTOMER_GETSALESAREAS.CUSTOMERNO.value = ret[:customer_num]
    User.BAPI_CUSTOMER_GETSALESAREAS.call
    User.BAPI_CUSTOMER_GETSALESAREAS.SALESAREAS.hashRows do |r|
      ret[:sales_org] = r["SALESORG"]
    end

    if result['TYPE'] == "S"
      ret[:emp_num] = login
      return ret
    else
      ret[:type] = result['TYPE']
      ret[:message] = result['MESSAGE']
      return nil
    end
  end

  def self.customer_detail(customer_num)
    User.BAPI_CUSTOMER_GETDETAIL2.reset
    User.BAPI_CUSTOMER_GETDETAIL2.CUSTOMERNO.value = customer_num
    User.BAPI_CUSTOMER_GETDETAIL2.call
		result = User.BAPI_CUSTOMER_GETDETAIL2.RETURN.value
    return User.BAPI_CUSTOMER_GETDETAIL2.CUSTOMERADDRESS.value
  end

  def self.contact_detail(emp_num)
    User.BAPI_BUSPARTNEREMPLOYE_GETLIST.reset
    idrange = User.BAPI_BUSPARTNEREMPLOYE_GETLIST.IDRANGE.structure
    idrange.SIGN.value   = 'I'
    idrange.OPTION.value = 'EQ'
    idrange.LOW.value    = emp_num
    User.BAPI_BUSPARTNEREMPLOYE_GETLIST.IDRANGE.value = [ idrange.value ]
    User.BAPI_BUSPARTNEREMPLOYE_GETLIST.call
    data = nil
    User.BAPI_BUSPARTNEREMPLOYE_GETLIST.ADDRESSDATA.hashRows do |r|
      data = r
    end
    return data
  end

  def self.change_password(emp_id, params)
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.reset
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.PARTNEREMPLOYEEID.value = emp_id
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.PASSWORD = params[:old_password]
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.NEW_PASSWORD = params[:new_password]
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.VERIFY_PASSWORD = params[:confirm_password]
    User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.call
    result = User.BAPI_PAR_EMPLOYEE_CHANGEPASSWO.RETURN.value
    return result["TYPE"] == "S"
  end
end